package acoes;

import java.awt.Robot;

import javafx.application.Platform;
import javafx.scene.control.Label;
import javafx.scene.effect.BlurType;
import javafx.scene.effect.DropShadow;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;

public class Aguardar extends Acao implements Cancelavel {

	private long millis;
	
	private volatile boolean isCancelar = false;
	
	private Label tempoRestante = new Label();

	public Aguardar(long millis) {
		this.millis = millis;
		tempoRestante.setTranslateX(20);
		tempoRestante.setTranslateY(120);
		tempoRestante.setFont(Font.font(30));
		tempoRestante.setText("Aguardando "+millis+"ms");
		tempoRestante.setEffect(new DropShadow(BlurType.GAUSSIAN, Color.WHITE, 20, 0.7, 0, 0));
		gui.add(tempoRestante);
	}

	@Override
	public boolean executar(Robot robo) {
		isCancelar = false;
		long start = System.currentTimeMillis();
		while (!isCancelar) {
			long decorrido = System.currentTimeMillis() - start;
			Platform.runLater(() -> {
				tempoRestante.setText("Aguardando "+(millis - decorrido)+"ms");
			});
			if (decorrido >= millis) break;
			try {
				Thread.sleep(50);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		return true;
	}

	@Override
	public void cancelar() {
		isCancelar = true;
	}

}
