package acoes;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;

import javafx.embed.swing.SwingFXUtils;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import main.BuscadorDeImagemDentroDeImagem;
import main.Carregador;
import view.Retangulo;

public class AguardarImagem extends Acao implements Cancelavel {
	
	private BufferedImage imagemBuscada;
	private Rectangle areaBuscada;
	
	private volatile boolean isCancelar;
	
	private Retangulo rectAreaBuscada;
	private Retangulo rectImgBuscada;
	
	public AguardarImagem(BufferedImage imagemBuscada, Rectangle areaBuscada) {
		this.imagemBuscada = imagemBuscada;
		this.areaBuscada = areaBuscada;
		rectAreaBuscada = new Retangulo(areaBuscada);
		
		if (Carregador.mostrarImagemBuscada) {
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
			rectImgBuscada = new Retangulo(
					//x:
					(Carregador.imagemBuscadaAncoradaNaDireita) ? 
							((int)(screenSize.getWidth() - imagemBuscada.getWidth()) - Carregador.margemHorizontalDaImagemBuscada)
							: Carregador.margemHorizontalDaImagemBuscada, 
							
					//y:
					(Carregador.imagemBuscadaAncoradaNoTopo) ? 
							Carregador.margemVerticalDaImagemBuscada 
							: ((int)(screenSize.getHeight() - imagemBuscada.getHeight()) - Carregador.margemVerticalDaImagemBuscada),
							
					//width e height:		
					imagemBuscada.getWidth(), imagemBuscada.getHeight());
			
			Image image = SwingFXUtils.toFXImage(imagemBuscada, null);
			ImageView imageView = new ImageView(image);
			imageView.setX(rectImgBuscada.getX());
			imageView.setY(rectImgBuscada.getY());
			gui.addAll(rectImgBuscada, rectAreaBuscada, imageView);
		} else {
			gui.add(rectAreaBuscada);
		}
	}

	@Override
	public boolean executar(Robot robo) {
		isCancelar = false;
		
		while (!isCancelar) {
			BufferedImage imagemPai = robo.createScreenCapture(areaBuscada);
			if (BuscadorDeImagemDentroDeImagem.buscarFilho(imagemPai, imagemBuscada) != null) {
				break;
			}
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		
		return true;
	}
	
	/**Cancela a espera, til para dar continuidade a sequncia de instrues.*/
	@Override
	public void cancelar() {
		isCancelar = true;
	}

}
