package acoes;

import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.util.HashMap;
import java.util.Map;

import javafx.scene.control.Alert.AlertType;
import main.MainFX;

public class DigitarEntradaAtual extends Acao {

	private Map<Character, Integer[]> caracteresEspeciais = new HashMap<>();
	
	public DigitarEntradaAtual() {
		caracteresEspeciais.put('\\', new Integer[]{KeyEvent.VK_NUMPAD0, KeyEvent.VK_NUMPAD0, KeyEvent.VK_NUMPAD9, KeyEvent.VK_NUMPAD2});
		caracteresEspeciais.put('/', new Integer[]{KeyEvent.VK_NUMPAD0, KeyEvent.VK_NUMPAD0, KeyEvent.VK_NUMPAD4, KeyEvent.VK_NUMPAD7});
	}
	
	@Override
	public boolean executar(Robot robo) {
		if (MainFX.entradaAtual == null || MainFX.entradaAtual.isEmpty()) {
			MainFX.mostrarMensagem(AlertType.WARNING, "Execuo Interrompida ao tentar Escrever Entrada Atual!", 
					"A execuo da Sequncia foi Interrompida porque no h mais Entradas para Escrever!");
			return false;
		}
		
		for(char character : MainFX.entradaAtual.toCharArray()){
			
			Integer[] codigo = caracteresEspeciais.get(character);
			
			if (codigo != null)
				processarCaracterEspecial(robo, codigo);
			else
				processarCaracterComum(robo, character);
			
		}
		return true;
	}

	private void processarCaracterEspecial(Robot robo, Integer... codigo) {
		robo.keyPress(KeyEvent.VK_ALT);
		robo.waitForIdle();
		
		for (Integer cod : codigo) {
			robo.keyPress(cod);
			robo.waitForIdle();
			robo.keyRelease(cod);
			robo.waitForIdle();
		}
		
		robo.keyRelease(KeyEvent.VK_ALT);
		robo.waitForIdle();
	}

	private void processarCaracterComum(Robot robo, char character) {
		robo.keyPress(KeyEvent.getExtendedKeyCodeForChar(character));
		robo.waitForIdle();
		robo.keyRelease(KeyEvent.getExtendedKeyCodeForChar(character));
		robo.waitForIdle();
	}
	
	

}
