package main;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;

import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleObjectProperty;
import main.BuscadorDeLinhaSelecionada.LinhaDaSelecao;

public class BuscadorDaCheckboxDaLinhaSelecionada {

	private BuscadorDeLinhaSelecionada buscadorDeLinhaSelecionada;

	Rectangle areaDaSelecao;
	int bordaEsquerdaDaAreaDeCheckbox;
	int bordaDireitaDaAreaDeCheckbox;

	private BufferedImage imagemDaCheckbox;

	/** No altere o valor desta property. */
	public final ObjectProperty<BufferedImage> areaComCheckboxBuscada = new SimpleObjectProperty<>();
	/** No altere o valor desta property. */
	public final ObjectProperty<BufferedImage> areaDaSelecaoBuscada = new SimpleObjectProperty<>();
	/** No altere o valor desta property. */
	public final ObjectProperty<BufferedImage> selecaoEncontrada = new SimpleObjectProperty<>();

	public BuscadorDaCheckboxDaLinhaSelecionada(BufferedImage imagemDaCheckbox,
			BuscadorDeLinhaSelecionada buscadorDeLinhaSelecionada, Rectangle areaDaSelecao,
			int bordaEsquerdaDaAreaDeCheckbox, int bordaDireitaDaAreaDeCheckbox) {
		this.imagemDaCheckbox = imagemDaCheckbox;
		this.buscadorDeLinhaSelecionada = buscadorDeLinhaSelecionada;
		this.areaDaSelecao = areaDaSelecao;
		this.bordaEsquerdaDaAreaDeCheckbox = bordaEsquerdaDaAreaDeCheckbox;
		this.bordaDireitaDaAreaDeCheckbox = bordaDireitaDaAreaDeCheckbox;
	}

	/**
	 * Recebe um screenshot de toda a tela, e retorna um Rectangle com as bouds do
	 * checkbox a ser clicado, ou retorna null caso no tenha encontrado ele ou a
	 * linha Selecionada.
	 */
	public Rectangle buscarCheckboxDaLinhaSelecionada(BufferedImage screenshot) {
		areaDaSelecaoBuscada.set(
				screenshot.getSubimage(areaDaSelecao.x, areaDaSelecao.y, areaDaSelecao.width, areaDaSelecao.height));
		LinhaDaSelecao linhaSelecionada = buscadorDeLinhaSelecionada
				.encontrarInicioEFimDaLinhaSelecionada(areaDaSelecaoBuscada.get(), areaDaSelecao.y);
		if (linhaSelecionada != null) {
			int width = bordaDireitaDaAreaDeCheckbox - bordaEsquerdaDaAreaDeCheckbox;
			int height = linhaSelecionada.fimY - linhaSelecionada.inicioY;
			selecaoEncontrada.set(screenshot.getSubimage(areaDaSelecao.x, linhaSelecionada.inicioY, areaDaSelecao.width, height));
			Rectangle boundsDaAreaComCheckboxBuscada = new Rectangle(bordaEsquerdaDaAreaDeCheckbox,
					linhaSelecionada.inicioY, width, height);
			System.out.println("boundsDaAreaComCheckboxBuscada: " + boundsDaAreaComCheckboxBuscada);
			areaComCheckboxBuscada
					.set(screenshot.getSubimage(boundsDaAreaComCheckboxBuscada.x, boundsDaAreaComCheckboxBuscada.y,
							boundsDaAreaComCheckboxBuscada.width, boundsDaAreaComCheckboxBuscada.height));
			Rectangle boundsDaCheckbox = BuscadorDeImagemDentroDeImagem.buscarFilho(areaComCheckboxBuscada.get(),
					imagemDaCheckbox);
			if (boundsDaCheckbox != null) {
				boundsDaCheckbox.x += boundsDaAreaComCheckboxBuscada.x;
				boundsDaCheckbox.y += boundsDaAreaComCheckboxBuscada.y;
			}
			System.out.println("boundsDaCheckbox: " + boundsDaCheckbox);
			return boundsDaCheckbox;
		} else {
			areaComCheckboxBuscada.set(null);
			selecaoEncontrada.set(null);
		}

		return null;
	}

}
